<!DOCTYPE html>
<html>
<head>
    <title> Task 40.20 - Danh sách Courses </title>
    <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script src="script.js"></script>
</head>
<body onload="onPageLoading()">
    <!-- Course Data Table -->
    <div class="container col-md-12">
        <div class="text-center my-4">
            <h2> Danh sách môn học </h2>
        </div>
        <button class="btn btn-success form-group" id="btn-add-course"><i class="fa fa-plus"></i>&nbsp; New Course </button>
        <table class="table table-bordered table-striped table-hover text-center" id="course-table" style="width: 100%;">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Code Name</th>
                    <th>Course Name</th>
                    <th>Course Image</th>
                    <th>Price</th>
                    <th>Discount Price</th>
                    <th>Duration</th>
                    <th>Level</th>
                    <th>Teacher</th>
                    <th>Teacher Image</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>
</body>
</div>
<!-- Vùng modal-->
<!-- Vùng Create Course Modal -->
<div>
    <div id="create-course-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Create new course</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-create-course-code">Course code</label>
                    </div>
                    <div class="col-sm-8">
                        <select id="input-create-course-code"  class="form-control">
                            <option value="NOT_SELECT_COURSE_CODE">Select Course Code</option>
                            <option value="FE_WEB_ANGULAR_101">FE_WEB_ANGULAR_101</option>
                            <option value="BE_WEB_PYTHON_301">BE_WEB_PYTHON_301</option>
                            <option value="FE_WEB_GRAPHQL_104">FE_WEB_GRAPHQL_104</option>
                            <option value="FE_WEB_JS_210">FE_WEB_JS_210</option>
                            <option value="FE_WEB_CSS_111">FE_WEB_CSS_111</option>
                            <option value="FE_WEB_WORDPRESS_111">FE_WEB_WORDPRESS_111</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-create-course-name">Course name</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-create-course-name" name="createcoursename" placeholder="Course name" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="image">Cover Image</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-create-course-image" name="coverimage" placeholder="Cover image" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-create-price">Price</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="number" id="input-create-price" name="createcourseprice" placeholder="Course Price" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-create-discount-price">Discount Price</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="number" id="input-create-discount-price" name="creatediscountprice" placeholder="Discount Price" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-create-duration">Duration</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-create-duration" name="createduration" placeholder="Duration" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-create-level">Level</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-create-level" name="createlevel" placeholder="Level" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-create-teacher">Teacher</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-create-teacher" name="createteacher" placeholder="Teacher" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="image">Teacher Image</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-create-teacher-image"  name="teacherimage" placeholder="Teacher image" class="form-control"/>
                    </div>
                </div>
            </form>
        </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-create-course">Create Course</button>
          </div>
        </div>
      </div>
    </div>
  </div>

<!-- Update voucher modal -->
<div>
  <div id="update-course-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="h5-modal-title">Update a Course</h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
            <form>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-course-code">Course code</label>
                    </div>
                    <div class="col-sm-8">
                        <select id="input-update-course-code"  class="form-control">
                            <option value="NOT_SELECT_COURSE_CODE">Select Course Code</option>
                            <option value="FE_WEB_ANGULAR_101">FE_WEB_ANGULAR_101</option>
                            <option value="BE_WEB_PYTHON_301">BE_WEB_PYTHON_301</option>
                            <option value="FE_WEB_GRAPHQL_104">FE_WEB_GRAPHQL_104</option>
                            <option value="FE_WEB_JS_210">FE_WEB_JS_210</option>
                            <option value="FE_WEB_CSS_111">FE_WEB_CSS_111</option>
                            <option value="FE_WEB_WORDPRESS_111">FE_WEB_WORDPRESS_111</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-course-name">Course name</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-update-course-name" name="createcoursename" placeholder="Course name" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-course-image">Cover Image</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-update-course-image"  name="coverimage" placeholder="Cover image" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-price">Price</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="number" id="input-update-price" name="createcourseprice" placeholder="Course Price" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-discount-price">Discount Price</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="number" id="input-update-discount-price" name="creatediscountprice" placeholder="Discount Price" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-duration">Duration</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-update-duration" name="createduration" placeholder="Duration" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-level">Level</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-update-level" name="createlevel" placeholder="Level" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-teacher">Teacher</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-update-teacher" name="createteacher" placeholder="Teacher" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="input-update-teacher-image">Teacher Image</label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" id="input-update-teacher-image"  name="teacherimage" placeholder="Teacher image" class="form-control"/>
                    </div>
                </div>
            </form>
        </div>
        <div class="modal-footer">
          <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
          <button class="btn btn-primary" id="btn-update-course">Update Course</button>
        </div>
      </div>
    </div>
  </div>
</div>

<!-- Delete confirm modal -->
<div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Course Delete Confirmation</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa thông tin course này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-course">Confirm</button>
            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
</div>

<script>
"use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
//Biến toàn cục để lưu trữ id course đang được update hoặc delete
var gCourseId = 0;
//Mảng chứa dữ liệu môn học
const gNOT_SELECT_COURSE_CODE = "NOT_SELECT_COURSE_CODE";
var gCourseObjects = [
    {
        "value": "FE_WEB_ANGULAR_101",
        "text": "ANGULAR_101"
    },
    {
        "value": "BE_WEB_PYTHON_301",
        "text": "PYTHON_301"
    },
    {
        "value": "FE_WEB_GRAPHQL_104",
        "text": "GRAPHQL_104"
    },
    {
        "value": "FE_WEB_JS_210",
        "text": "JS_210"
    },
    {
        "value": "FE_WEB_WORDPRESS_111",
        "text": "WORDPRESS_111"
    }, 
    {
        "value": "FE_WEB_CSS_111",
        "text": "CSS_111"
    }
];

//Khai báo biến mảng hằng số chứa danh sách tên các thuộc tính
const gCOURSE_COLS = ["id", "courseCode", "courseName", "coverImage", "price", "discountPrice", "duration", "level", "teacherName", "teacherPhoto", "action"];
//Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
const gCOURSES_ID_COL = 0;
const gCOURSES_CODE_COL = 1;
const gCOURSES_NAME_COL = 2;
const gCOURSE_COVER_IMAGE_COL = 3;
const gCOURSES_PRICE_COL = 4;
const gCOURSES_DISCOUNT_PRICE_COL = 5;
const gCOURSES_DURATION_COL = 6;
const gCOURSES_LEVEL_COL = 7;
const gCOURSES_TEACHER_COL = 8;
const gCOURSES_TEACHER_IMAGE_COL = 9;
const gCOURSES_ACTION_COL = 10;
//Đổ dữ liệu vào bảng và thực hiện nút Sửa (Edit), Xoá (Delete)

var gCourseTable = $("#course-table").DataTable({
    columns: [
        { data: gCOURSE_COLS[gCOURSES_ID_COL] },
        { data: gCOURSE_COLS[gCOURSES_CODE_COL] },
        { data: gCOURSE_COLS[gCOURSES_NAME_COL] },
        { data: gCOURSE_COLS[gCOURSE_COVER_IMAGE_COL] },
        { data: gCOURSE_COLS[gCOURSES_PRICE_COL] },
        { data: gCOURSE_COLS[gCOURSES_DISCOUNT_PRICE_COL] },
        { data: gCOURSE_COLS[gCOURSES_DURATION_COL] },
        { data: gCOURSE_COLS[gCOURSES_LEVEL_COL] },
        { data: gCOURSE_COLS[gCOURSES_TEACHER_COL] },
        { data: gCOURSE_COLS[gCOURSES_TEACHER_IMAGE_COL] },
        { data: gCOURSE_COLS[gCOURSES_ACTION_COL] },
    ],
    columnDefs: [
        {
            //Định nghĩa lại cột Course Code
            targets: gCOURSES_CODE_COL,
            render: function(data) {
                return getCourseTextByCourseValue(data);
            }
        },
        {
            //Định nghĩa lại cột Action
            targets: gCOURSES_ACTION_COL,
            className: "text-center",
            defaultContent: `
            <div class="row">
                <div class = "col-md-5">
                    <button class="btn btn-primary btn-edit"> <i class="far fa-edit"></i></button>
                </div>
                <div class = "col-md-5">
                    <button class="btn btn-danger btn-delete"> <i class="far fa-trash-alt"></i></button>
                </div>
            </div>
            `
        },
        {
            //Định nghĩa lại cột ảnh cover môn học
            targets: gCOURSE_COVER_IMAGE_COL,
            className: "text-center",
            data: "img",
            render: function (data) {
                return '<img src="' + data + '" alt="' + data + '"height="100%" width="100%"/>';
            }
        },
        {
            //Định nghĩa lại cột ảnh giáo viên
            targets: gCOURSES_TEACHER_IMAGE_COL,
            classname: "text-center",
            data: "img",
            render: function (data) {
                return '<img src="' + data + '" alt="' + data + '"height="100%" width="100%"/>';
            }
        }
    ],
    autoWidth: false
});


/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
//2 - C: Gán sự kiện Create - Thêm mới course
$("#btn-add-course").on("click", function(){
    onBtnAddNewCourseClick();
});
//3 - U: Gán sự kiện Update - Sửa 01 Course
$("#course-table").on("click", ".btn-edit", function(){
    onBtnEditNewCourseClick(this);
});
//4 - D: Gán sự kiện Delete - Xoá 01 Course
$("#course-table").on("click", ".btn-delete", function(){
    onBtnDeleteCourseClick(this);
});
//Gán sự kiện cho nút Create Course (Trên modal)
$("#btn-create-course").on("click", function(){
    onBtnCreateCourseClick();
});
//Gán sự kiện cho nút Update Course (Trên modal)
$("#btn-update-course").on("click", function() {
    onBtnUpdateCourseClick(); 
});
//Gán sự kiện cho nút Confirm Delete Course (Trên modal)
$("#btn-confirm-delete-course").on("click", function(){
    onBtnConfirmDeleteCourseClick();
});
/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
function onPageLoading(){
    "use strict";
    //1 - R: Read / Load course to DataTable
    loadDataToCourseTable(gCoursesDB.courses);
}
//Hàm xử lý sự kiện khi nút Thêm mới môn học được click
function onBtnAddNewCourseClick(){
    //hiển thị modal trắng lên
    $("#create-course-modal").modal("show");
}
//Hàm xử lý sự kiện khi ấn icon Edit trên bảng được click
function onBtnEditNewCourseClick(paramBtnEdit){
    //Lưu thông tin courseId đang được edit vào biến toàn cục
    gCourseId = getCourseIdFromButton(paramBtnEdit);
    //Load dữ liệu vào các trường dữ liệu trong modal
    showCourseDataToModal(gCourseId);
    //Hiển thị modal lên
    $("#update-course-modal").modal("show");
}

//Hàm xử lý sự kiện Create Course Modal Click
function onBtnCreateCourseClick(){
    //Khai báo đối tượng chứa Course Data
    var vCourseObj = {
        "id": 0,
        "courseCode": "",
        "courseName": "",
        "coverImage": "",
        "price": "",
        "discountPrice": "",
        "duration": "",
        "level": "",
        "teacherName": "",
        "teacherPhoto": ""
    };
    //Bước 1: Thu thập dữ liệu
    getCreateCourseData(vCourseObj);
    //Bước 2: Validate Insert
    var vIsCourseValidate = validateCourseData(vCourseObj);
    if(vIsCourseValidate){
        //Bước 3: Insert Course
        insertCourse(vCourseObj);
        //Bước 4: Xử lý Front-end
        alert("Thêm course thành công!");
        loadDataToCourseTable(gCoursesDB.courses);
        resetUpdateCourseForm();
        $("#create-course-modal").modal("hide");
    }
}

//Hàm xử lý sự kiện khi ấn nút Update Course trên Modal
function onBtnUpdateCourseClick(){
    //Khai báo đối tượng chứa Course Data
    var vCourseObj = {
        "id": 0,
        "courseCode": "",
        "courseName": "",
        "coverImage": "",
        "price": "",
        "discountPrice": "",
        "duration": "",
        "level": "",
        "teacherName": "",
        "teacherPhoto": ""
    };
    //Bước 1: Thu thập dữ liệu
    getUpdateCourseData(vCourseObj);
    //Bước 2: Validate dữ liệu update
    var vIsCourseValidate = validateCourseData(vCourseObj);
    if(vIsCourseValidate){
        //Bước 3: Update Course Data
        updateCourse(vCourseObj);
        //Bước 4: Xử lý Front-End
        alert("Sửa Course Thành Công!");
        loadDataToCourseTable(gCoursesDB.courses);
        resetUpdateCourseForm();
        $("#update-course-modal").modal("hide");
    }
}

//Hàm xử lý sự kiện khi icon Delete Course trên bảng được click
function onBtnDeleteCourseClick(paramBtnDelete){
    //Lưu thông tin courseId đang được edit vào biến toàn cục
    gCourseId = getCourseIdFromButton(paramBtnDelete);
    //Hiển thị Modal lên
    $("#delete-confirm-modal").modal("show");
}
//Hàm xử lý sự kiện khi ấn nút Confirm trên Delete Voucher Modal
function onBtnConfirmDeleteCourseClick(){
    //thu thập dữ liệu (không có)
    //validate dữ liệu (không có)
    //xoá course
    deleteCourse(gCourseId);
    //xử lý hiển thị front-end
    alert("Xoá course thành công!");
    loadDataToCourseTable(gCoursesDB.courses);
    $("#delete-confirm-modal").modal("hide");
}

/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
//Hàm lấy text course theo value của course
function getCourseTextByCourseValue(paramCourse) {
    "use strict";
    var vTextCourse = "";
    for (var bI = 0; bI < gCourseObjects.length; bI++) {
        if(gCourseObjects[bI].value == paramCourse){
            vTextCourse = gCourseObjects[bI].text;
        }
    };
    return vTextCourse;
}

/** load course array to DataTable
 * in: course array
 * out: course array table has data
 **/ 
function loadDataToCourseTable(paramCourseArr) {
    gCourseTable.clear();
    gCourseTable.rows.add(paramCourseArr);
    gCourseTable.draw();
}

//Hàm show Course Objects lên Modal
function showCourseDataToModal(paramCourseId){
    var vCourseIndex = getIndexFormCourseId(paramCourseId);
    $("#input-update-course-code").val(gCoursesDB.courses[vCourseIndex].courseCode);
    $("#input-update-course-name").val(gCoursesDB.courses[vCourseIndex].courseName);
    $("#input-update-course-image").val(gCoursesDB.courses[vCourseIndex].coverImage);
    $("#input-update-price").val(gCoursesDB.courses[vCourseIndex].price);
    $("#input-update-discount-price").val(gCoursesDB.courses[vCourseIndex].discountPrice);
    $("#input-update-duration").val(gCoursesDB.courses[vCourseIndex].duration);
    $("#input-update-level").val(gCoursesDB.courses[vCourseIndex].level); 
    $("#input-update-teacher").val(gCoursesDB.courses[vCourseIndex].teacherName);
    $("#input-update-teacher-image").val(gCoursesDB.courses[vCourseIndex].teacherPhoto);
}

//Hàm dựa vào Button Detail (Edit or Delete) xác định được Course Id
function getCourseIdFromButton(paramButton){
    var vTableRow = $(paramButton).parents("tr");
    var vCourseRowData = gCourseTable.row(vTableRow).data();
    return vCourseRowData.id;
}

/* Get Course Index From Course Id
//input: paramCourseId là courseId cần tìm index
//output: trả về chỉ số (index) trong mảng course
*/
function getIndexFormCourseId(paramCourseId){
    var vCourseIndex = -1;
    var vCourseFound = false;
    var vLoopIndex = 0;
    while(!vCourseFound && vLoopIndex < gCoursesDB.courses.length){
        if(gCoursesDB.courses[vLoopIndex].id === paramCourseId){
            vCourseIndex = vLoopIndex;
            vCourseFound = true;
        }
        else {
            vLoopIndex ++;
        }
    }
    return vCourseIndex;
}

//Hàm thu thập dữ liệu để Create Course
function getCreateCourseData(paramCourseObj){
    paramCourseObj.id = getNextId();
    paramCourseObj.courseCode = $("#input-create-course-code").val().trim();
    paramCourseObj.courseName = $("#input-create-course-name").val();
    paramCourseObj.coverImage = $("#input-create-course-image").val();
    paramCourseObj.price = $("#input-create-price").val();
    paramCourseObj.discountPrice = $("#input-create-discount-price").val();
    paramCourseObj.duration = $("#input-create-duration").val();
    paramCourseObj.level = $("#input-create-level").val();
    paramCourseObj.teacherName = $("#input-create-teacher").val();
    paramCourseObj.teacherPhoto = $("#input-create-teacher-image").val();

}

//Hàm Validate Data
function validateCourseData(paramCourseObj){
    if(paramCourseObj.courseCode === gNOT_SELECT_COURSE_CODE) {
        alert("[courseCode] cần chọn");
        return false;
    }
    if(paramCourseObj.courseName === "") {
        alert("[courseName] cần nhập");
        return false;
    }
    if(paramCourseObj.coverImage === "") {
        alert("[coverImage] cần nhập");
        return false;
    }
    if(paramCourseObj.price === "") {
        alert("[Price] cần nhập");
        return false;
    }
    if(paramCourseObj.discountPrice === "") {
        alert("[discountPrice] cần nhập");
        return false;
    }
    if(paramCourseObj.duration === "") {
        alert("[duration] cần nhập");
        return false;
    }
    if(paramCourseObj.level === "") {
        alert("[level] cần nhập");
        return false;
    }
    if(paramCourseObj.teacherName === "") {
        alert("[teacherName] cần nhập");
        return false;
    }
    if(paramCourseObj.teacherPhoto === "") {
        alert("[teacherPhoto] cần nhập");
        return false;
    }
    return true;
}

//Hàm thực hiện insert course vào mảng
function insertCourse(paramCourseObj){
    gCoursesDB.courses.push(paramCourseObj)
} 

//Hàm load course array to DataTable
/** load course array to DataTable
 * in: course array
 * out: course table has data
 */
function loadDataToCourseTable(paramCourseArr){
    gCourseTable.clear();
    gCourseTable.rows.add(paramCourseArr);
    gCourseTable.draw();
}

//Hàm xoá trắng Update Course
function resetCreateVoucherForm(){
    $("#input-create-course-code").val("");
    $("#input-create-course-name").val("");
    $("#input-create-course-image").val("");
    $("#input-create-price").val("");
    $("#input-create-discount-price").val("");
    $("#input-create-duration").val("");
    $("#input-create-level").val("");
    $("#input-create-teacher").val("");
    $("#input-create-teacher-image").val(""); 
}

//Hàm lấy ra được id course tiếp theo, dùng khi thêm mới course
function getNextId(){
    var vNextId = 0;
    //Nếu mảng chưa có phần tử nào, thì id sẽ bắt đầu từ từ 1
    if(gCoursesDB.courses.length == 0){
        vNextId = 1;
    }
    else {
        vNextId = gCoursesDB.courses[gCoursesDB.courses.length -1].id + 1;
    }
    return vNextId;
}

//Hàm thu thập dữ liệu để Update Course
function getUpdateCourseData(paramCourseObj){
    paramCourseObj.id = gCourseId;
    paramCourseObj.courseCode = $("#input-update-course-code").val().trim();
    paramCourseObj.courseName = $("#input-update-course-name").val();
    paramCourseObj.coverImage = $("#input-update-course-image").val();
    paramCourseObj.price = $("#input-update-price").val();
    paramCourseObj.discountPrice = $("#input-update-discount-price").val();
    paramCourseObj.duration = $("#input-update-duration").val();
    paramCourseObj.level = $("#input-update-level").val();
    paramCourseObj.teacherName = $("#input-update-teacher").val();
    paramCourseObj.teacherPhoto = $("#input-update-teacher-image").val();
}

//Hàm xoá trắng form Create Course
function resetUpdateCourseForm(){
    $("#input-update-course-code").val("");
    $("#input-update-course-name").val("");
    $("#input-update-course-image").val("");
    $("#input-update-price").val("");
    $("#input-update-discount-price").val("");
    $("#input-update-duration").val("");
    $("#input-update-level").val("");
    $("#input-update-teacher").val("");
    $("#input-update-teacher-image").val(""); 
}

//Hàm thực hiện Update Course vào mảng
function updateCourse(paramCourseId){
    debugger;
    var vCourseIndex = getIndexFormCourseId(gCourseId);
    gCoursesDB.courses.splice(vCourseIndex, 1, paramCourseId);
}

//Hàm xoá Course theo Id Course
function deleteCourse(paramCourseId){
    var vCourseIndex = getIndexFormCourseId(paramCourseId);
    gCoursesDB.courses.splice(vCourseIndex, 1);
}

</script>
</html>